/*
 * Automatically generated from spybye.rpc
 */

#ifndef _SPYBYE_RPC_
#define _SPYBYE_RPC_

#define VIRUSSCAN_TAG	0x01
#define VIRUSRESULT_TAG	0x02

#define EVTAG_HAS(msg, member) ((msg)->member##_set == 1)
#define EVTAG_ASSIGN(msg, member, args...) (*(msg)->member##_assign)(msg, ## args)
#define EVTAG_GET(msg, member, args...) (*(msg)->member##_get)(msg, ## args)
#define EVTAG_ADD(msg, member) (*(msg)->member##_add)(msg)
#define EVTAG_LEN(msg, member) ((msg)->member##_length)

struct dangerousload;
struct dangerous_report;
struct virusscan;
struct virusresult;

/* Tag definition for dangerousload */
enum dangerousload_ {
  DANGEROUSLOAD_TIME_IN_SECONDS=1,
  DANGEROUSLOAD_PARENT_URL=2,
  DANGEROUSLOAD_DANGEROUS_URL=3,
  DANGEROUSLOAD_VIRUS_RESULT=4,
  DANGEROUSLOAD_DIGEST=5,
  DANGEROUSLOAD_MAX_TAGS
};

/* Structure declaration for dangerousload */
struct dangerousload {
  u_int32_t time_in_seconds_data;
  int (*time_in_seconds_assign)(struct dangerousload *, const u_int32_t);
  int (*time_in_seconds_get)(struct dangerousload *, u_int32_t *);
  char *parent_url_data;
  int (*parent_url_assign)(struct dangerousload *, const char *);
  int (*parent_url_get)(struct dangerousload *, char * *);
  char *dangerous_url_data;
  int (*dangerous_url_assign)(struct dangerousload *, const char *);
  int (*dangerous_url_get)(struct dangerousload *, char * *);
  char *virus_result_data;
  int (*virus_result_assign)(struct dangerousload *, const char *);
  int (*virus_result_get)(struct dangerousload *, char * *);
  u_int8_t digest_data[16];
  int (*digest_assign)(struct dangerousload *, const u_int8_t *);
  int (*digest_get)(struct dangerousload *, u_int8_t **);

  u_int8_t time_in_seconds_set;
  u_int8_t parent_url_set;
  u_int8_t dangerous_url_set;
  u_int8_t virus_result_set;
  u_int8_t digest_set;
};

struct dangerousload *dangerousload_new();
void dangerousload_free(struct dangerousload *);
void dangerousload_clear(struct dangerousload *);
void dangerousload_marshal(struct evbuffer *, const struct dangerousload *);
int dangerousload_unmarshal(struct dangerousload *, struct evbuffer *);
int dangerousload_complete(struct dangerousload *);
void evtag_marshal_dangerousload(struct evbuffer *, u_int8_t, const struct dangerousload *);
int evtag_unmarshal_dangerousload(struct evbuffer *, u_int8_t, struct dangerousload *);
int dangerousload_time_in_seconds_assign(struct dangerousload *, const u_int32_t);
int dangerousload_time_in_seconds_get(struct dangerousload *, u_int32_t *);
int dangerousload_parent_url_assign(struct dangerousload *, const char *);
int dangerousload_parent_url_get(struct dangerousload *, char * *);
int dangerousload_dangerous_url_assign(struct dangerousload *, const char *);
int dangerousload_dangerous_url_get(struct dangerousload *, char * *);
int dangerousload_virus_result_assign(struct dangerousload *, const char *);
int dangerousload_virus_result_get(struct dangerousload *, char * *);
int dangerousload_digest_assign(struct dangerousload *, const u_int8_t *);
int dangerousload_digest_get(struct dangerousload *, u_int8_t **);
/* --- dangerousload done --- */

/* Tag definition for dangerous_report */
enum dangerous_report_ {
  DANGEROUS_REPORT_TIME_IN_SECONDS=1,
  DANGEROUS_REPORT_REMOTE_IP=2,
  DANGEROUS_REPORT_REPORT=3,
  DANGEROUS_REPORT_MAX_TAGS
};

/* Structure declaration for dangerous_report */
struct dangerous_report {
  u_int32_t time_in_seconds_data;
  int (*time_in_seconds_assign)(struct dangerous_report *, const u_int32_t);
  int (*time_in_seconds_get)(struct dangerous_report *, u_int32_t *);
  char *remote_ip_data;
  int (*remote_ip_assign)(struct dangerous_report *, const char *);
  int (*remote_ip_get)(struct dangerous_report *, char * *);
  struct dangerousload *report_data;
  int (*report_assign)(struct dangerous_report *, const struct dangerousload *);
  int (*report_get)(struct dangerous_report *, struct dangerousload **);

  u_int8_t time_in_seconds_set;
  u_int8_t remote_ip_set;
  u_int8_t report_set;
};

struct dangerous_report *dangerous_report_new();
void dangerous_report_free(struct dangerous_report *);
void dangerous_report_clear(struct dangerous_report *);
void dangerous_report_marshal(struct evbuffer *, const struct dangerous_report *);
int dangerous_report_unmarshal(struct dangerous_report *, struct evbuffer *);
int dangerous_report_complete(struct dangerous_report *);
void evtag_marshal_dangerous_report(struct evbuffer *, u_int8_t, const struct dangerous_report *);
int evtag_unmarshal_dangerous_report(struct evbuffer *, u_int8_t, struct dangerous_report *);
int dangerous_report_time_in_seconds_assign(struct dangerous_report *, const u_int32_t);
int dangerous_report_time_in_seconds_get(struct dangerous_report *, u_int32_t *);
int dangerous_report_remote_ip_assign(struct dangerous_report *, const char *);
int dangerous_report_remote_ip_get(struct dangerous_report *, char * *);
int dangerous_report_report_assign(struct dangerous_report *, const struct dangerousload *);
int dangerous_report_report_get(struct dangerous_report *, struct dangerousload **);
/* --- dangerous_report done --- */

/* Tag definition for virusscan */
enum virusscan_ {
  VIRUSSCAN_BUFFER=1,
  VIRUSSCAN_CONTEXT=2,
  VIRUSSCAN_MAX_TAGS
};

/* Structure declaration for virusscan */
struct virusscan {
  u_int8_t *buffer_data;
  u_int32_t buffer_length;
  int (*buffer_assign)(struct virusscan *, const u_int8_t *, u_int32_t);
  int (*buffer_get)(struct virusscan *, u_int8_t * *, u_int32_t *);
  u_int8_t *context_data;
  u_int32_t context_length;
  int (*context_assign)(struct virusscan *, const u_int8_t *, u_int32_t);
  int (*context_get)(struct virusscan *, u_int8_t * *, u_int32_t *);

  u_int8_t buffer_set;
  u_int8_t context_set;
};

struct virusscan *virusscan_new();
void virusscan_free(struct virusscan *);
void virusscan_clear(struct virusscan *);
void virusscan_marshal(struct evbuffer *, const struct virusscan *);
int virusscan_unmarshal(struct virusscan *, struct evbuffer *);
int virusscan_complete(struct virusscan *);
void evtag_marshal_virusscan(struct evbuffer *, u_int8_t, const struct virusscan *);
int evtag_unmarshal_virusscan(struct evbuffer *, u_int8_t, struct virusscan *);
int virusscan_buffer_assign(struct virusscan *, const u_int8_t *, u_int32_t);
int virusscan_buffer_get(struct virusscan *, u_int8_t * *, u_int32_t *);
int virusscan_context_assign(struct virusscan *, const u_int8_t *, u_int32_t);
int virusscan_context_get(struct virusscan *, u_int8_t * *, u_int32_t *);
/* --- virusscan done --- */

/* Tag definition for virusresult */
enum virusresult_ {
  VIRUSRESULT_RESULT=1,
  VIRUSRESULT_CONTEXT=2,
  VIRUSRESULT_MAX_TAGS
};

/* Structure declaration for virusresult */
struct virusresult {
  char *result_data;
  int (*result_assign)(struct virusresult *, const char *);
  int (*result_get)(struct virusresult *, char * *);
  u_int8_t *context_data;
  u_int32_t context_length;
  int (*context_assign)(struct virusresult *, const u_int8_t *, u_int32_t);
  int (*context_get)(struct virusresult *, u_int8_t * *, u_int32_t *);

  u_int8_t result_set;
  u_int8_t context_set;
};

struct virusresult *virusresult_new();
void virusresult_free(struct virusresult *);
void virusresult_clear(struct virusresult *);
void virusresult_marshal(struct evbuffer *, const struct virusresult *);
int virusresult_unmarshal(struct virusresult *, struct evbuffer *);
int virusresult_complete(struct virusresult *);
void evtag_marshal_virusresult(struct evbuffer *, u_int8_t, const struct virusresult *);
int evtag_unmarshal_virusresult(struct evbuffer *, u_int8_t, struct virusresult *);
int virusresult_result_assign(struct virusresult *, const char *);
int virusresult_result_get(struct virusresult *, char * *);
int virusresult_context_assign(struct virusresult *, const u_int8_t *, u_int32_t);
int virusresult_context_get(struct virusresult *, u_int8_t * *, u_int32_t *);
/* --- virusresult done --- */

#endif  /* _SPYBYE_RPC_ */
